declare type SocketConfig = {
    name?: string;
    type: number;
    host: string;
    port: number;
    username?: string;
    password?: string;
    method?: string;
    udpRelay?: boolean;
    dnsServer?: string;
    vpnMode?: number;
    applications?: Array<string>;
    mergeDefaultRoute?: boolean;
    routes?: Array<string>;
};
export declare const DEFAULT_ROUTES: string[];
export declare const APPLICATION_MODE: {
    GLOBAL_MODE: number;
    WHITELIST_MODE: number;
    BLACKLIST_MODE: number;
};
export declare const ErrorCode: {
    NO_ERROR: number;
    UNEXPECTED: number;
    VPN_PERMISSION_NOT_GRANTED: number;
    INVALID_SERVER_CREDENTIALS: number;
    UDP_RELAY_NOT_ENABLED: number;
    SERVER_UNREACHABLE: number;
    VPN_START_FAILURE: number;
    ILLEGAL_SERVER_CONFIGURATION: number;
    SHADOWSOCKS_START_FAILURE: number;
    CONFIGURE_SYSTEM_PROXY_FAILURE: number;
    NO_ADMIN_PERMISSIONS: number;
    UNSUPPORTED_ROUTING_TABLE: number;
    SYSTEM_MISCONFIGURED: number;
};
export declare const TunnelStatus: {
    INVALID: number;
    DISCONNECTED: number;
    CONNECTING: number;
    CONNECTED: number;
    RECONNECTING: number;
};
export declare const SocketType: {
    SHADOWSOCKS: number;
    SOCKS5: number;
    HTTP: number;
};
declare type Vpn2sockType = {
    startTunnel(tunnelId: string, config: SocketConfig): Promise<boolean>;
    stopTunnel(tunnelId: string): Promise<boolean>;
    getActivedTunnelId(): Promise<string>;
    getTunnelStatus(): Promise<number>;
    isRunning(tunnelId: string): Promise<boolean>;
    isReachable(host: string, port: number): Promise<boolean>;
    getPackageList(): Promise<Array<Object>>;
};
declare const _default: Vpn2sockType;
export default _default;
